(defun C:LAYERINFO (/ c d f ln lt ly n x)
  (setq M:LOGNAME   (strcat
                      (getvar "dwgprefix")
                      (substr (getvar "DWGNAME")
                              1
                              (- (strlen (getvar "dwgname")) 4)
                              ) ;_ end of substr
                      ) ;_ end of strcat
        M:LOGNAME   (strcat M:LOGNAME ".txt")
        M:FUNC " Layer"
        OLDERR  *ERROR*
        *ERROR* MYERROR
        )
  (tblset "layer")
  (M:OPEN)
  (princ "\n LAYER:\n\n" M:LOGDAT)
  (write-line
    "  Layername               Status     Farbe    Linientyp        -strke      Plotbar\n"
    M:LOGDAT
    ) ;_ end of write-line
  (setq cl (getvar "clayer"))           ; get current layer
  (setq n 0)
  (setq x (next T))                     ; get first layer
  (while x
    (cond
      (M:ROTOR
       (setq M:ROTOR NIL)
       (princ (strcat "\r/ Arbeite" M:FUNC))
       )
      (t (setq M:ROTOR (princ (strcat "\r\\ Arbeite" M:FUNC))))
      ) ;_ end of cond
    (setq n  (1+ n)
          ly (fld 2 x)                  ; layer name
          ln (fld 6 x)                  ; linetype name
          c  (fld 62 x)                 ; color number
          f  (logand (fld 70 x) 1)      ; "frozen" flag
          lt (tblsearch "ltype" ln)     ; linetype table entry
;;;          d  (fld 3 lt)                 ; linetype prose description
          pl (cdr (assoc 290 (entget (tblobjname "LAYER" ly))))
          lt (cdr (assoc 370 (entget (tblobjname "LAYER" ly))))
          ) ;_ end of setq
    (write-line
      (strcat
        (if (= ly cl)
          "* "
          "  "
          )                             ; flag current layer
        (strfill ly 25)                 ; edit layer name
        (strfill
          (cond
            ((and (= f 1) (minusp c)) "Gefr./Aus")
            ((= f 1) "Gefroren")        ; edit status
            ((< c 0) "Aus")
            (T "Ein")
            ) ;_ end of cond
          11
          ) ;_ end of strfill
        (strfill (itoa (abs c)) 8)      ; edit color number
        (strfill ln 18)                 ; edit linetype name
        (strfill (cond ((= lt -3) "Vorgabe")
                       (T (itoa lt))
                       ) ;_ end of cond
                 14
                 ) ;_ end of strfill
        (strfill (if (= pl 1)
                   "Ja"
                   "Nein"
                   ) ;_ end of if
                 7
                 ) ;_ end of strfill
;;;        (substr d 1 30)                 ; edit linetype description
        ) ;_ end of strcat
      M:LOGDAT
      ) ;_ end of write-line
    (setq x (next nil))                 ; get next layer entry
    ) ;_ end of while
  (princ (if (= n 0)
           "-KEIN EINTRAG-\n"
           M:STRB
           ) ;_ end of if
         M:LOGDAT
         ) ;_ end of princ
  (M:CLOSE)
  (prompt
    (strcat "\n=>Protokolldatei:\n" M:LOGNAME "\nerstellt.")
    )
  (setq *error* olderr)
  )

(prompt "\nstarten mit 'Layerinfo'")

(defun M:CLOSE (/)
  (close M:LOGDAT)
  ) ;_ end of defun

(defun M:OPEN (/)
  (setq M:LOGDAT (open M:LOGNAME "a"))
  ) ;_ end of defun

(defun tblset (tbl / new)
  (setq tblname tbl)                    ; set table name
  (setq tblents nil)                    ; start with null list
  (setq new (cdr (assoc 2 (tblnext tbl T)))) ; get first entry name
  (while new
    (setq tblents (cons new tblents))   ; add to list
    (setq new (cdr (assoc 2 (tblnext tbl)))) ; get next entry name
    )                                   ;ende while
  (if (/= tblents nil)
    (setq tblents (acad_strlsort tblents)) ; sort the name list
    ) ;_ end of if
  )

(defun next (first / temp)
  (setq temp (car tblents))             ; get next name from list
  (if temp
    (progn                              ; if not end of list...
      (setq tblents (cdr tblents))      ; chop from list
      (tblsearch tblname temp)          ; get table entry for this name
      ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of defun

(defun fld (num lst)
  (cdr (assoc num lst))
  ) ;_ end of defun

(defun strfill (s len)
  (substr (strcat s "                              ") 1 len)
  ) ;_ end of defun

(defun myerror (s)                      ; If an error (such as CTRL-C) occurs
                                        ; while this command is active...
  (if (/= s "Funktion abgebrochen")
    (princ (strcat "\nFehler: " s))
    ) ;_ end of if
  ;(setvar "cmdecho" OLDCMD)             ; Restore saved modes
  (close M:LOGDAT)
  (setq *error* olderr)                 ; Restore old *error* handler
  (princ)
  ) ;_ end of defun